﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Steema.TeeChart.Web;
using System.Collections;
using System.IO;
using System.Drawing;
using Steema.TeeChart.Styles;

namespace ChartZoom
{
    public partial class _Default : System.Web.UI.Page
    {
        protected Steema.TeeChart.Tools.SeriesHotspot seriesHotspot;
        override protected void OnInit(EventArgs e)
        {
            //
            // CODEGEN: This call is required by the ASP.NET Web Form Designer.
            //
            InitializeComponent();
            base.OnInit(e);

        }
        private void InitializeComponent()
        {

        }


        protected void Page_Load(object sender, EventArgs e)
        {
            Steema.TeeChart.Chart chart = WebChart1.Chart;
            WebChart1.Style["position"] = "absolute";
            WebChart1.Style["left"] = "20px";
            WebChart1.Style["top"] = "20px";

            MemoryStream tmpChart = new MemoryStream();

            if (Session["ch1"] == null)
            {
                chart.Aspect.View3D = false;
                //setup Chart
                if (chart.Chart.Series.Count < 2)
                    chart.Series.Add(new Steema.TeeChart.Styles.Line());


                if (chart.Tools.Count < 1)
                {
                    chart.Tools.Add(new Steema.TeeChart.Tools.ZoomTool());
                    chart.Tools.Add(new Steema.TeeChart.Tools.SeriesHotspot());
                }

                ((Steema.TeeChart.Tools.ZoomTool)chart.Tools[0]).ZoomPenColor = Color.OliveDrab;
                ((Steema.TeeChart.Tools.SeriesHotspot)chart.Tools[1]).Style = MarksStyles.LabelPercentTotal;
                ((Line)chart.Series[0]).Color = Color.Green;
                ((Line)chart.Series[0]).Pointer.Pen.Visible = false;
                ((Line)chart.Series[0]).Pointer.HorizSize = 2;
                ((Line)chart.Series[0]).Pointer.VertSize = 2;

                chart.Series[0].Color = Color.FromArgb(255, 199, 26);

                chart.Series[0].FillSampleValues(36);
                //export Chart to a MemoryStream template
                chart.Export.Template.Save(tmpChart);
                //save template to a Session variable
                Session.Add("ch1", tmpChart);
            }
            else
            {
                //retrieve the session stored Chart
                tmpChart = (MemoryStream)Session["ch1"];
                //set the Stream position to 0 as the last read/write
                //will have moved the position to the end of the stream
                tmpChart.Position = 0;
                //import saved Chart
                chart.Import.Template.Load(tmpChart);

                //check whether zoom request is being sent
                CheckZoom(WebChart1);
            }
        }
        private void CheckZoom(WebChart wChart)
        {
            ArrayList zoomedState = (ArrayList)Session[wChart.ID + "Zoomed"];
            zoomedState = ((Steema.TeeChart.Tools.ZoomTool)wChart.Chart.Tools[0]).SetCurrentZoom(Request,
               zoomedState);
            if (zoomedState == null)
                Session.Remove(wChart.ID + "Zoomed");
            else
                Session.Add(wChart.ID + "Zoomed", zoomedState);

        }

    }
}
